/*      
   Tsunami for KallistiOS ##version##
        
   sound.cpp

   (c)2002 Dan Potter
*/

#include <tsu/sound.h>

CVSID("$Id: sound.cpp,v 1.2 2002/10/17 06:08:55 bardtx Exp $");

int Sound::m_default_vol = 240;

Sound::Sound(const char *fn) {
	m_index = SFXHND_INVALID;
	loadFromFile(fn);
}

Sound::Sound() {
	m_index = SFXHND_INVALID;
}

Sound::~Sound() {
	if (m_index != SFXHND_INVALID)
		snd_sfx_unload(m_index);
}

void Sound::play() {
	play(m_default_vol, 0x80);
}

void Sound::play(int vol) {
	play(vol, 0x80);
}

void Sound::play(int vol, int pan) {
	snd_sfx_play(m_index, vol, pan);
}

void Sound::loadFromFile(const char *fn) {
	m_index = snd_sfx_load(fn);
	if (m_index == SFXHND_INVALID) {
		dbglog(DBG_WARNING, "Sound::loadFromFile: Can't load '%s'\n", fn);
		assert( false );
	}
}

// Set the default volume value
void Sound::setDefaultVolume(int vol) {
	m_default_vol = vol;
}
        
