/* KallistiOS ##version##

   dc/sound/sfxmgr.h
   (c)2002 Dan Potter

   $Id: sfxmgr.h,v 1.5 2002/09/27 22:40:55 bardtx Exp $

*/

#ifndef __DC_SOUND_SFXMGR_H
#define __DC_SOUND_SFXMGR_H

#include <sys/cdefs.h>
__BEGIN_DECLS

#include <arch/types.h>

/* Sound effect handle type */
typedef uint32 sfxhnd_t;
#define SFXHND_INVALID 0

/* Load a sound effect from a WAV file and return a handle to it */
sfxhnd_t snd_sfx_load(const char *fn);

/* Unload a single sample */
void snd_sfx_unload(sfxhnd_t idx);

/* Unload all loaded samples and free their SPU RAM */
void snd_sfx_unload_all();

/* Play a sound effect with the given volume and panning; if the sound
   effect is in stereo, the panning is ignored. */
void snd_sfx_play(sfxhnd_t idx, int vol, int pan);

__END_DECLS

#endif	/* __DC_SOUND_SFXMGR_H */

